/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.aufgabe.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class AufgabeKommentarTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String autor;
    public java.lang.String getAutor(){
      return autor;
    }
    protected final java.util.Date zeitpunkt;
    public java.util.Date getZeitpunkt(){
      return zeitpunkt;
    }
  protected final de.ivu.elect.business.aufgabe.entity.AufgabeTK aufgabeTK;
    public de.ivu.elect.business.aufgabe.entity.AufgabeTK getAufgabeTK(){
      return aufgabeTK;
    }

  public AufgabeKommentarTK(
java.lang.String autor
, java.util.Date zeitpunkt
,   de.ivu.elect.business.aufgabe.entity.AufgabeTK aufgabeTK
  ) {
    super();


      this.autor = autor;
      this.zeitpunkt = zeitpunkt;
        this.aufgabeTK = aufgabeTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((autor == null) ? 0 : autor.hashCode());
                    result = result + ((zeitpunkt == null) ? 0 : zeitpunkt.hashCode());
        
                    result = result + ((aufgabeTK == null) ? 0 : aufgabeTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof AufgabeKommentarTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        AufgabeKommentarTK other = (AufgabeKommentarTK) obj;

                if (autor == null) {
          if (other.autor != null) {
            return false;
          }
        } else if (!autor.equals(other.autor)) {
          return false;
        }
                if (zeitpunkt == null) {
          if (other.zeitpunkt != null) {
            return false;
          }
        } else if (!zeitpunkt.equals(other.zeitpunkt)) {
          return false;
        }
        
                if (aufgabeTK == null) {
          if (other.aufgabeTK != null) {
            return false;
          }
        } else if (!aufgabeTK.equals(other.aufgabeTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(aufgabeTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL, AufgabeKommentarConstants.MESSAGE_KEY_AUTOR_EINZAHL, autor));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(AufgabeKommentarConstants.MESSAGE_KEY_ENTITY_EINZAHL, AufgabeKommentarConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, zeitpunkt));
        
        return result;
      }


            @Override
            public String toString() {
            return "AufgabeKommentarTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"autor="+autor
                            +", zeitpunkt="+zeitpunkt
                                        +", aufgabeTK="+aufgabeTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(AufgabeKommentarConstants.MESSAGE_KEY_AUTOR_EINZAHL) + "=" +

                                    autor
                
                          + ", " + messages.getMessageForMessageKey(AufgabeKommentarConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL) + "=" +

                                    zeitpunkt
                
                                      + ", " +  toStringLokalisiert(aufgabeTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends AufgabeKommentar> java.util.Map<AufgabeKommentarTK, E> mappeAufgabeKommentarNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(AufgabeKommentar::getAufgabeKommentarTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<AufgabeKommentar, AufgabeKommentarTK> getAufgabeKommentarToTKFunction() {
                return AufgabeKommentar::getAufgabeKommentarTK;
                }

}
